' Einfaches Lupen-Morphing: Vergrssert Ausschnitt in einer
' TrueColor-Windows-Bitmapdatei
' Version mit f=x/(1+x^4)

DIM fa!(1, 2)

INPUT "Quellbild-Datei (ohne .BMP!)"; q$

' Trgerdatei sofort analysieren
OPEN q$ + ".bmp" FOR INPUT AS 1
CLOSE 1
OPEN q$ + ".bmp" FOR BINARY AS 1
IF LOF(1) < 54 THEN
  PRINT "Fehler: Keine .BMP-Datei (zu kurz)"
  CLOSE 1
  END
END IF
bfType$ = INPUT$(2, 1)
IF bfType$ <> "BM" THEN
  PRINT "Keine gltige .BMP-Datei"
  CLOSE 1
  END
END IF
bfSize& = CVL(INPUT$(4, 1))
zuKopieren1$ = INPUT$(4, 1)     ' 1:1 bernehmen
bfOffBits& = CVL(INPUT$(4, 1))  ' ab hier beginnen die Bilddaten
biSize& = CVL(INPUT$(4, 1))

biWidth& = CVL(INPUT$(4, 1))
biHeight& = CVL(INPUT$(4, 1))
biPlanes% = CVI(INPUT$(2, 1))
IF biPlanes% <> 1 THEN
  PRINT ".BMP-Datei irgend einer zuknfigen Windowsversion"
  CLOSE 1
  END
END IF
biBitCount% = CVI(INPUT$(2, 1))
IF biBitCount% <> 24 THEN
  PRINT "Keine 24-Bit-Bilddatei; bitte als TrueColor abspeichern!"
  CLOSE 1
  END
END IF
biCompression& = CVL(INPUT$(4, 1))
IF biCompression& <> 0& THEN  ' BI_RGB
  PRINT "Bilddatei ist komprimiert; bitte unkomprimiert abspeichern"
  CLOSE 1
  END
END IF
' Grssencheck
' 14=sizeof(BITMAPFILEHEADER)
IF bfOffBits& < biSize& + 14& THEN
  PRINT "Bilddatei korrupt"
  CLOSE 1
  END
END IF
' Grsse Rasterzeile
gRast& = 3& * biWidth& + 3& AND -4

IF LOF(1) < bfOffBits& + biHeight& * gRast& THEN
  PRINT "Bilddatei zu klein (mglicherweise korrupt)"
  CLOSE 1
  END
END IF

' Jetzt sind alle Parameter o.k.
biSizeImage& = CVL(INPUT$(4, 1))
zuKopieren2$ = INPUT$(CINT(biSize& - 24&), 1) ' Daten ab biSizeImage

PRINT "Grsse Quellbild:"; biWidth&; "x"; biHeight&; "Pixel"
INPUT "Morph-Lupenentrum (x,y)"; xMo!, yMo!
INPUT "Maximale Vergrsserung im Zentrum"; f!
INPUT "x-Pixelshift"; xSh!
INPUT "y-Pixelshift"; ySh!
INPUT "Zentrierskalierung"; s!

INPUT "Neue Bildbreite (Leereingabe=bisherige)"; xBr&
IF xBr& = 0& THEN
  xBr& = biWidth&
END IF
INPUT "Neue Bildhhe (Leereingabe=bisherige)"; yBr&
IF yBr& = 0& THEN
  yBr& = biHeight&
END IF
INPUT "Ziel-Bilddatei (ohne .BMP!)"; z$

' Lcke am Schluss berechnen
lck% = CINT(xBr& AND 3&)
seekOffs& = 14& + biSize&
bildL& = yBr& * (3& * xBr& + CLNG(lck%))

OPEN z$ + ".bmp" FOR OUTPUT AS 2
' BITMAPFILEHEADER schreiben
PRINT #2, "BM"; MKL$(seekOffs& + bildL&);
PRINT #2, zuKopieren1$; MKL$(seekOffs&);
' ^_ Anmerkung: bfOffBits neu berechnet
' BITMAPINFOHEADER schreiben
PRINT #2, MKL$(biSize&); MKL$(xBr&); MKL$(yBr&); MKI$(biPlanes%);
PRINT #2, MKI$(biBitCount%); MKL$(biCompression&);
PRINT #2, MKL$(bildL&); zuKopieren2$;

' Eigentliches Bild erzeugen

k! = 1! - 1! / f!

xFa! = CSNG(biWidth&) / (CSNG(xBr&) * xSh!)
xOff! = xFa! / 2! + xMo! / xSh!
yFa! = CSNG(biHeight&) / (CSNG(yBr&) * ySh!)
yOff! = yFa! / 2! + (CSNG(biHeight&) - yMo!) / ySh!

FOR y& = 1& TO yBr&
  y1! = CSNG(y&) * yFa! - yOff!
  FOR x& = 1& TO xBr&
    x1! = CSNG(x&) * xFa! - xOff!
    r! = SQR(x1! * x1! + y1! * y1!)
    r1! = (r! - k! * r! / (1! + r! ^ 6!)) * s!
    x3! = x1! * r1! / r! * xSh! + xMo!
    y3! = y1! * r1! / r! * ySh! + (CSNG(biHeight&) - yMo!)
    ' Pixel interpolieren
    xp& = CLNG(x3!) - 1&
    px! = x3! - CSNG(xp&) - .5
    yp& = CLNG(y3!) - 1&
    py! = y3! - CSNG(yp&) - .5
    IF xp& < 0& THEN
      xp& = 0&
    ELSEIF xp& > biWidth& - 2& THEN
      xp& = biWidth& - 2&
    END IF
    IF yp& < 0& THEN
      yp& = 0&
    ELSEIF yp& > biHeight& - 2& THEN
      yp& = biHeight& - 2&
    END IF
    FOR i% = 0 TO 1
      SEEK 1, 1& + bfOffBits& + gRast& * (yp& + CLNG(i%)) + 3& * xp&
      h$ = INPUT$(6, 1)
      FOR j% = 0 TO 2
        fa!(i%, j%) = (1! - px!) * CSNG(ASC(MID$(h$, 1 + j%, 1))) + px! * CSNG(ASC(MID$(h$, 4 + j%, 1)))
      NEXT j%
    NEXT i%
    FOR i% = 0 TO 2
      PRINT #2, CHR$(CINT((1 - py!) * fa!(0, i%) + py! * fa!(1, i%)));
    NEXT i%
  NEXT x&
  PRINT #2, SPACE$(lck%);
NEXT y&

CLOSE 2
CLOSE 1

